//Made with Blockbench
//Paste this code into your mod.

public static class Modelmeganeura extends ModelBase {
	private final ModelRenderer Head;
	private final ModelRenderer BodyS1;
	private final ModelRenderer BodyS2;
	private final ModelRenderer RightWing;
	private final ModelRenderer LeftWing;
	private final ModelRenderer Leg1;
	private final ModelRenderer Leg2;
	private final ModelRenderer Leg3;
	private final ModelRenderer Leg4;
	private final ModelRenderer Leg5;
	private final ModelRenderer Leg6;

	public Modelmeganeura() {
		textureWidth = 128;
		textureHeight = 128;

		Head = new ModelRenderer(this);
		Head.setRotationPoint(-2.0F, 13.0F, -9.0F);
		Head.cubeList.add(new ModelBox(Head, 0, 0, -2.0F, -2.0F, -4.0F, 4, 4,
				4, 0.0F, false));

		BodyS1 = new ModelRenderer(this);
		BodyS1.setRotationPoint(0.0F, 24.0F, 0.0F);
		BodyS1.cubeList.add(new ModelBox(BodyS1, 104, 117, -4.0F, -13.0F,
				-9.0F, 4, 3, 8, 0.0F, false));

		BodyS2 = new ModelRenderer(this);
		BodyS2.setRotationPoint(0.0F, 24.0F, 0.0F);
		BodyS2.cubeList.add(new ModelBox(BodyS2, 92, 110, -3.0F, -13.0F, -1.0F,
				2, 2, 16, 0.0F, false));

		RightWing = new ModelRenderer(this);
		RightWing.setRotationPoint(-1.0F, 11.0F, -6.0F);
		RightWing.cubeList.add(new ModelBox(RightWing, 88, 0, 1.0F, 0.0F,
				-3.0F, 15, 0, 5, 0.0F, false));

		LeftWing = new ModelRenderer(this);
		LeftWing.setRotationPoint(-3.5F, 11.0F, -6.5F);
		LeftWing.cubeList.add(new ModelBox(LeftWing, 88, 0, -15.5F, 0.0F,
				-2.5F, 15, 0, 5, 0.0F, false));

		Leg1 = new ModelRenderer(this);
		Leg1.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg1.cubeList.add(new ModelBox(Leg1, 0, 125, -1.0F, -10.0F, -8.0F, 1,
				2, 1, 0.0F, false));

		Leg2 = new ModelRenderer(this);
		Leg2.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg2.cubeList.add(new ModelBox(Leg2, 0, 125, -1.0F, -10.0F, -5.0F, 1,
				2, 1, 0.0F, false));

		Leg3 = new ModelRenderer(this);
		Leg3.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg3.cubeList.add(new ModelBox(Leg3, 0, 125, -1.0F, -10.0F, -2.0F, 1,
				2, 1, 0.0F, false));

		Leg4 = new ModelRenderer(this);
		Leg4.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg4.cubeList.add(new ModelBox(Leg4, 0, 125, -4.0F, -10.0F, -2.0F, 1,
				2, 1, 0.0F, false));

		Leg5 = new ModelRenderer(this);
		Leg5.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg5.cubeList.add(new ModelBox(Leg5, 0, 125, -4.0F, -10.0F, -5.0F, 1,
				2, 1, 0.0F, false));

		Leg6 = new ModelRenderer(this);
		Leg6.setRotationPoint(0.0F, 24.0F, 0.0F);
		Leg6.cubeList.add(new ModelBox(Leg6, 0, 125, -4.0F, -10.0F, -8.0F, 1,
				2, 1, 0.0F, false));
	}

	@Override
	public void render(Entity entity, float f, float f1, float f2, float f3,
			float f4, float f5) {
		Head.render(f5);
		BodyS1.render(f5);
		BodyS2.render(f5);
		RightWing.render(f5);
		LeftWing.render(f5);
		Leg1.render(f5);
		Leg2.render(f5);
		Leg3.render(f5);
		Leg4.render(f5);
		Leg5.render(f5);
		Leg6.render(f5);
	}
	public void setRotationAngle(ModelRenderer modelRenderer, float x, float y,
			float z) {
		modelRenderer.rotateAngleX = x;
		modelRenderer.rotateAngleY = y;
		modelRenderer.rotateAngleZ = z;
	}

	public void setRotationAngles(float f, float f1, float f2, float f3,
			float f4, float f5, Entity e) {
		super.setRotationAngles(f, f1, f2, f3, f4, f5, e);
		this.Head.rotateAngleY = f3 / (180F / (float) Math.PI);
		this.Head.rotateAngleX = f4 / (180F / (float) Math.PI);
		this.LeftWing.rotateAngleY = MathHelper.cos(f * 0.6662F) * f1;
		this.RightWing.rotateAngleY = MathHelper.cos(f * 0.6662F
				+ (float) Math.PI)
				* f1;
	}
}